// BinRead, viewer used by Multiex Commander for textfiles

#include <dos.h>
#include <conio.h>
#include <stdio.h>
#include  <stdlib.h>
#include <string.h>
#include "myview.h"
#include <fcntl.h>

FileInfo	MainFile;
int 		Pages;
int		CP;
//BYTE 		Wrap=0;
BYTE		Buffer[22*80];
FILE 		*File;
BYTE 		ClearBuf[4096];

#pragma inline

int ExitProgram(BYTE *Mess)
{
  clrscr();
 _setcursortype(_NORMALCURSOR);
 printf(Mess);
 exit(0);
 return 0;
}

int CheckMainFile(BYTE *MFile)
{
 FILE *M ;
 int E;
 M = fopen(MFile, "rb");
 if (!M) return 1;
  E= strlen(MFile);
  if (E>74) {E-=74;} else E=0;
 strcpy(MainFile.Filename, &MFile[E]);
 fclose(M);
 return 0;
}


int CheckPages(void)
{

 long total=0;
 int  P=0;
 int P2=0;
 BYTE Xit=0;
 File = fopen (MainFile.Filename, "rb");
 fseek(File, 0l, SEEK_END);
 total=ftell(File);
 P2 = (int) (total / (21*78)) ;
 fclose (File);

// P = (int) total/21;
// if ((long)P*21<total) P++;
 return P2;
}

int LoadBuffer(long Page)
{
 long FilePos;
 BYTE *Error;
 setmem((void *) &Buffer[0], 21*78, 0);
 FilePos = Page * 21*78;
 fseek(File, FilePos, SEEK_SET);
 fread(Buffer, 21*78, 1, File);
 return 0;
}

int ShowPage(void)
{
 float Per;
 void *p;
 int y,x,xl, ym;
 int L=0;
 textbackground(11);
 textcolor(15);
 puttext(2, 3, 80, 23, ClearBuf);
 p=&Buffer[0];
 y=2*160+2;
 ym=21;
 x=78;
 xl=160-x*2;
   asm {
   mov bx, 0xb800
   mov es, bx
   xor di, di
   push ds
   lds si, p
   mov dx, y
 // add dx, x
   mov di, dx
   mov dx, ym
   sub di, xl
   }
 Loop:
  asm {
  add di, xl
  cmp dx, 0x00
  je  End
  dec dx
  mov bx, x
  }
 Loop2:
 asm {
  cmp bx, 0x00
  je Loop
  dec bx
  lodsb
  dec si
  sub ax, 123
  jc ColorCh
  mov ax, 0x1e
  }
PutEm:
asm {
  movsb
  stosb
  jmp Loop2
  }
ColorCh:
asm {
  clc
  add ax, 65
  jc TCol
  mov ax, 0x1e
  jmp PutEm
  }
TCol:
asm {
  mov ax, 0x1f
  jmp PutEm
  }
 End:
 asm {pop ds }
 Per=100;
 if (Pages>0) Per=((float) (CP)/ (float) (Pages))*100;

 gotoxy(76, 25); cprintf("    ", (int) Per);
 gotoxy(76, 25); cprintf("%d%", (int) Per);

 return 0;
}

int ViewFile(void)
{
 BYTE Page=0;
 BYTE Line[90];
 BYTE Lines=0;
 BYTE Xit=0, Xit2=0;
 BYTE ch;
 BYTE *Error;
 int check;
 CP=0;
 File=fopen(MainFile.Filename, "rb");
 MainFile.StartOff=0;
 LoadBuffer(CP);
 ShowPage();

 while (!Xit)
 {
 ch=getch();
 switch (ch) {
 case 27 : Xit=1; Xit2=1; break;
 case 81 : if (CP<=Pages-1)
	   {CP++;
	   LoadBuffer(CP);
	   ShowPage(); }
	   break;
 case 73 : if (CP>0)
	    { CP--;
	    LoadBuffer(CP);
	    ShowPage(); }
	    break;

 }
}

fclose(File);
return 0;
}


int SetUpScreen(void)
{
 int t;
 textbackground(1);
 textcolor(15);
 clrscr();
 _setcursortype(_NOCURSOR);
 textbackground(1);
 gotoxy(1,1); cprintf("");
 gotoxy(63,1);cprintf("ͻ");
 gotoxy(1,2);
 cprintf("Ķ");
 for (t=3; t<=23; t++) {
 gotoxy(1, t); cprintf("");
 gotoxy(80, t); cprintf("");
 }
 gotoxy(1,24);
 cprintf("");
 gotoxy(80,24);
 cprintf("");
 for (t=2; t<=79; t++)
 {
  gotoxy(t, 24); cprintf("");
 }
 textcolor(15);
 textbackground(0);
 gotoxy(17, 1); cprintf("Multiex Commander BREAD v1.0, 2000, SadCom Ltd.");
 textcolor(15);
 textbackground(7);
 gotoxy(1, 25); cprintf(MainFile.Filename);
// gotoxy(28, 2); cprintf(PackedFile.Filename);
 textbackground(15);
 textcolor(1);
 gettext(2, 3, 80, 23,ClearBuf);
return 0;
}


int main(int argc, BYTE *argv[])
{


// if (argc<=3) ExitProgram("Not enough arguments to do anything!\n");
 if (CheckMainFile(argv[1])) ExitProgram("File given that does not exist!\n");
// if (strcmp(argv[4], "-wrap")==0) Wrap=1;
// if (argc>=5) strcpy(PackedFile.Filename, argv[4]);
 Pages=CheckPages();
 SetUpScreen();
 ViewFile();
 ExitProgram("ended.\n");
 return 0;
}